CREATE TABLE f_bdt_Loc (
  PLANETE VARCHAR2(255),
  SOLARSYSTEM VARCHAR2(255),
  QUADRAN VARCHAR2(255)
);

PROMPT -> Fonction de de rcupration des locations :
DECLARE
  CURSOR AllLocation IS
  SELECT DISTINCT CUSTOMERADRESSE AS PLANETE, SOLARSYSTEM, QUADRAN FROM F_BDE_CUSTOMER;

  TYPE type_PLANETE IS TABLE OF VARCHAR2(255);
  TYPE type_SOLARSYSTEM IS TABLE OF VARCHAR2(255);
  TYPE type_QUADRAN IS TABLE OF VARCHAR2(255);
  
  t_PLANETE type_PLANETE;
  t_SOLARSYSTEM type_SOLARSYSTEM;
  t_QUADRAN type_QUADRAN;
  
  PLANETE VARCHAR2(255);
  SOLARSYSTEM VARCHAR2(255);
  QUADRAN VARCHAR2(255);
  compteur number;
  idx1 PLS_INTEGER;
  idx2 PLS_INTEGER;
BEGIN
  OPEN AllLocation;
  FETCH AllLocation BULK COLLECT INTO t_PLANETE, t_SOLARSYSTEM, t_QUADRAN;
  CLOSE AllLocation;
  FOR idx1 IN 1..t_PLANETE.count LOOP
    PLANETE := t_PLANETE(idx1);
    SOLARSYSTEM := t_SOLARSYSTEM(idx1);
    QUADRAN := t_QUADRAN(idx1);
    FOR idx2 IN 1..t_PLANETE.count LOOP
      if ((t_PLANETE(idx1) = t_PLANETE(idx2)) AND (idx1 <> idx2)) 
        then
          if (SOLARSYSTEM <> t_SOLARSYSTEM(idx2))
            then
              SOLARSYSTEM := NULL;
          end if;
          if (QUADRAN <> t_QUADRAN(idx2))
            then
              QUADRAN := NULL;
          end if;
      end if;
    END LOOP;
    INSERT INTO f_bdt_Loc VALUES (PLANETE,SOLARSYSTEM,QUADRAN);
  END LOOP;
END;
/

CREATE TABLE f_bdt_Location (
  PLANETE VARCHAR2(255),
  SOLARSYSTEM VARCHAR2(255),
  QUADRAN VARCHAR2(255)
);

INSERT INTO f_bdt_Location (PLANETE, SOLARSYSTEM, QUADRAN)
  SELECT DISTINCT PLANETE, SOLARSYSTEM, QUADRAN 
  FROM f_bdt_Loc;

PROMPT ///////////////////////////////////////
PROMPT Nombre de lignes de la vue de Location sans les doubles:
SELECT count(*) FROM f_bdt_Loc;