PROMPT
PROMPT **** CREATION DU TYPE DATE ****
PROMPT
/
CREATE OR REPLACE TYPE F_BDT_TYPE_DATES AS OBJECT (
  DATE_VENTE VARCHAR2(255),
  MEMBER FUNCTION getDATE_VENTE RETURN DATE,
  MEMBER FUNCTION getJDS RETURN VARCHAR2,
  MEMBER FUNCTION getJDA RETURN number,
  MEMBER FUNCTION getSEMAINE RETURN number,
  MEMBER FUNCTION getMOIS RETURN number,
  MEMBER FUNCTION getTrimestre RETURN number,
  MEMBER FUNCTION getYear RETURN varchar2
);
/
PROMPT
PROMPT **********  Implementation des methodes  ***************
PROMPT
/

CREATE OR REPLACE TYPE BODY F_BDT_TYPE_DATES
 IS
 MEMBER FUNCTION getDATE_VENTE RETURN DATE
  IS
    tmp VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN 
        --Reformater un varchar2 en date: 
        regex := '^([0-9]{4}-[0-1][0-9]-[0-3][0-9])'; 
        tmp := regexp_substr(self.date_vente, regex); 

        if (length(tmp) = 10) 
          then return to_date(tmp, 'yyyy-mm-dd');
          else return to_date('1999-01-01','yyyy-mm-dd'); 
        end if; 
    END ;
  MEMBER FUNCTION getJDS RETURN VARCHAR2
  IS
  tmp DATE;
  tmp2 NUMBER;
  BEGIN
    tmp := self.getDATE_VENTE();
    if (tmp = to_date('1999-01-01','yyyy-mm-dd'))
    then
      return 'EXCEPTION';
    else  
      return to_char(tmp,'DAY');
    END IF;
  END;
  MEMBER FUNCTION getJDA RETURN number
  IS
    tmp DATE;
  BEGIN
    tmp := self.getDATE_vente();
    if (tmp = to_date('1999-01-01', 'yyyy-mm-dd'))
      then return 0;
    else
      if((TO_CHAR(LAST_DAY(TO_DATE('01/02/'|| self.getYEAR(), 'dd/mm/yyyy')), 'DD') = 29) AND (to_number(to_char(tmp,'DDD')) > 59))
        then
        --anne bissextile :
        if (TO_CHAR(LAST_DAY(tmp), 'DD') = 29)
          then
          --29 fvirer :
            return to_number(366);
          else
            return to_number(to_char(tmp,'DDD'))-1;
      end if;
     else
      --anne non bissextile :
        return to_number(to_char(tmp,'DDD'));
    end if;
  end if;
  END ;
  MEMBER FUNCTION getSEMAINE RETURN number
  IS
    date_vente DATE;
  BEGIN
      date_vente := self.getDATE_VENTE();
      if (date_vente = to_date('1999-01-01', 'yyyy-mm-dd'))
        then return 0;
        else return to_number(to_char(date_vente,'IW'));
      end if;
  END ;
  MEMBER FUNCTION getMOIS RETURN number
  IS
    date_vente DATE;
  BEGIN
      date_vente := self.getDATE_VENTE();
      if (date_vente = to_date('1999-01-01', 'yyyy-mm-dd'))
        then return 0;
        else return to_number(to_char(date_vente,'MM'));
      end if;
  END ;
  MEMBER FUNCTION getTrimestre RETURN number
  IS
    date_vente DATE;
  BEGIN
      date_vente := self.getDATE_VENTE();
      if (date_vente = to_date('1999-01-01', 'yyyy-mm-dd'))
        then return 0;
        else return to_char( date_vente , 'Q' );
      end if;
  END ;
  MEMBER FUNCTION getYear RETURN VARCHAR2
  IS
    date_vente DATE;
  BEGIN
      date_vente := self.getDATE_VENTE();
      if (date_vente = to_date('1999-01-01', 'yyyy-mm-dd'))
        then return '1999';
        else return to_char( date_vente , 'YYYY' );
      end if;
  END ;
    
END ;
/
PROMPT
PROMPT *********  Creation de la table DATES *****************
PROMPT
CREATE TABLE F_BDT_DATES OF F_BDT_TYPE_DATES;
PROMPT
PROMPT *********  Insert dans la table depuis la table extraction *****************
PROMPT
INSERT INTO F_BDT_DATES(DATE_VENTE)
  SELECT DISTINCT v.DATE_VENTE
  FROM F_BDE_SELLING v;