PROMPT;
PROMPT **** CREATION DU TYPE POUR LES VENTES *****;
PROMPT;
/
CREATE OR REPLACE TYPE F_BDT_TYPE_SELLING AS OBJECT (
  FK_DATE VARCHAR2(255),
  FK_CUSTOMER VARCHAR2(255),
  FK_FACTORY VARCHAR2(255),
  FK_PRODUCT VARCHAR2(255),
  MEMBER FUNCTION getFK_DATE RETURN DATE,
  MEMBER FUNCTION getFK_CUSTOMER RETURN VARCHAR2,
  MEMBER FUNCTION getFK_FACTORY RETURN VARCHAR2,
  MEMBER FUNCTION getFK_PRODUCT RETURN VARCHAR2
);
/
PROMPT;
PROMPT **********  Implementation des methodes  ***************;
PROMPT;
/

CREATE OR REPLACE TYPE BODY F_BDT_TYPE_SELLING
  IS
  MEMBER FUNCTION getFK_DATE RETURN DATE
  IS
    tmp VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^([0-9]{4}-[0-1][0-9]-[0-3][0-9])';
    tmp := regexp_substr(self.FK_DATE, regex);
  
    if (length(tmp) = 10)
      then return to_date(tmp, 'yyyy.mm.dd');
      else return to_date('1999-01-01', 'yyyy.mm.dd');
    end if;
  END ;
  MEMBER FUNCTION getFK_CUSTOMER RETURN VARCHAR2
  IS
    tmp1 VARCHAR2(3);
    tmp VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(LSL)';
    tmp1 := regexp_substr(self.FK_CUSTOMER, regex);
  
    if (length(tmp1) <> 3)
      then return 'ERREUR 1';
    end if;
    
    regex := '^(LSL\d*)';
    tmp := regexp_substr(self.FK_CUSTOMER, regex);
    
    if (length(tmp) > 3)
      then RETURN tmp;
      else return 'ERREUR 2';
    end if;
  END ;
  MEMBER FUNCTION getFk_Factory RETURN VARCHAR2
  IS
    tmp1 VARCHAR2(5);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(\d+)';
    tmp1 := regexp_substr(self.Fk_Factory, regex);
  
    if ((length(tmp1) = 0) OR (to_number(tmp1)=0) )
      then return 'ERROR';
      ELSE RETURN tmp1;
    end if;
  END ;
  MEMBER FUNCTION getFK_PRODUCT RETURN VARCHAR2
  IS
    tmp1 VARCHAR2(2);
    tmp VARCHAR2(20);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(LS)';
    tmp1 := regexp_substr(self.FK_PRODUCT, regex);
  
    if (length(tmp1) <> 2)
      then return 'ERREUR 1';
    end if;
    
    regex := '^(LS\d*)';
    tmp := regexp_substr(self.FK_PRODUCT, regex);
    
    if (length(tmp) > 2)
      then RETURN tmp;
      else return 'ERREUR 2';
    end if;
  END ;
END ;
/
PROMPT;
PROMPT ****  CREATION DE LA TABLE DES VENTES A PARTIR DU TYPE ****;
PROMPT;
CREATE TABLE F_BDT_SELLING OF F_BDT_TYPE_SELLING;

PROMPT;
PROMPT *********  INSERTION DANS LA TABLE DEPUIS LA TABLE EXTRACTION *****************;
PROMPT;
INSERT INTO F_BDT_SELLING(FK_DATE, FK_CUSTOMER, Fk_Factory, FK_product)
  SELECT v.DATE_VENTE, v.customernumber, v.Factory, v.Product
  FROM F_BDE_SELLING v;