PROMPT
PROMPT **** CREATION DE LA TABLE ****

CREATE TABLE f_dw_dates (
  DATE_VENTE DATE,
  JDS VARCHAR2(10),
  JDA number,
  SEMAINE number,
  MOIS number,
  TRIMESTRE number,
 ANNEE VARCHAR2(5)
)PARTITION BY HASH(ANNEE) PARTITIONS 10;
PROMPT;
PROMPT *********  Creation des index *****************;
PROMPT;
CREATE UNIQUE INDEX idx_F_DW_DATES_DATE_VENTE ON F_DW_DATES (DATE_VENTE);
PROMPT;
PROMPT *********  Creation des contraintes *****************;
PROMPT;
ALTER TABLE F_DW_DATES ADD CONSTRAINT cstr_F_DW_DATE_VENTE PRIMARY KEY (DATE_VENTE);
ALTER TABLE F_DW_DATES ADD CONSTRAINT cstr_F_DW_JDS CHECK (JDS IN ('LUNDI   ','MARDI   ','MERCREDI','JEUDI   ','VENDREDI','SAMEDI  ','DIMANCHE', 'EXCEPTION'));
ALTER TABLE F_DW_DATES ADD CONSTRAINT cstr_F_DW_JDA CHECK (JDA BETWEEN 0 and 366);
ALTER TABLE F_DW_DATES ADD CONSTRAINT cstr_F_DW_SEMAINE CHECK (SEMAINE BETWEEN 0 and 53);
ALTER TABLE F_DW_DATES ADD CONSTRAINT cstr_F_DW_MOIS CHECK (MOIS BETWEEN 0 and 12);
ALTER TABLE F_DW_DATES ADD CONSTRAINT cstr_F_DW_TRIMESTRE CHECK (TRIMESTRE BETWEEN 0 and 4);