PROMPT
PROMPT **** CREATION DE LA TABLE ****

CREATE TABLE f_dw_factory (
  Factory VARCHAR2(5),
  Creation DATE,
  YearOfCreation VARCHAR2(4),
  YearOfCreationSeg VARCHAR2(4),
  Capacity VARCHAR2(9),
  Planete Varchar2(20),
  SolarSystem VARCHAR2(20),
  Quadran VARCHAR2(6)
);
PROMPT
PROMPT *********  Creation des index *****************
PROMPT
CREATE UNIQUE INDEX idx_F_DW_Factory_Factory ON F_DW_factory (Factory);
PROMPT
PROMPT *********  Creation des contraintes *****************
PROMPT
ALTER TABLE f_dw_factory ADD CONSTRAINT cstr_F_DW_Factory PRIMARY KEY (Factory);
ALTER TABLE f_dw_factory ADD CONSTRAINT cstr_F_DW_Capacity CHECK (Capacity IN ('ERROR','LOW','MEDIUM','HIGH','VERY HIGH'));
ALTER TABLE f_dw_factory ADD CONSTRAINT cstr_F_DW_YearOfCreation CHECK (YearOfCreation BETWEEN '0000' AND '9999');