-- A rendre :
--        -Requte sql
--        -Le resultat
--        -Interprtation du rsultat


PROMPT **********************************************************************************
PROMPT **** Question 1 : Analyser les ventes en fonction de la capacité des usines *****
PROMPT **********************************************************************************
PROMPT 
PROMPT **** Nombre de vente par capacite ****
SELECT f.capacity AS r1, count(*) AS q1
FROM f_dw_factory f, f_dw_ticket ti
WHERE ti.fk_factory = f.factory AND capacity <> 'ERROR'
GROUP BY f.capacity;

PROMPT 
PROMPT ********************************** Interpretation ****************************************************
PROMPT 
PROMPT On peut voir que les usines qui ont une plus grande capacit ont l air de vendre mieux, ce qui parait logique car elles produisent plus
PROMPT Cependant on peut aussi voir avec le rsultat qu il n y a pas de diffrence signifiante entre les usines de capacit MEDIUM ( 3< capacity <7 )
PROMPT et HIGH ( 6 < High <11).

PROMPT Il faudrait faire l analyse en proportion

PROMPT **** Nombre d usine par capacite ****
SELECT f.capacity AS r2, count(*) AS q2
FROM f_dw_factory f
WHERE capacity <> 'ERROR'
GROUP BY f.capacity;


PROMPT **** Analyse en proportion ****

SELECT r1 AS Capacity, q1 AS Ventes, q2 AS NbFactory, ROUND(q1/q2) AS VentesParCapacite FROM
  (SELECT f.capacity AS r1, count(*) AS q1
  FROM f_dw_factory f, f_dw_ticket ti
  WHERE ti.fk_factory = f.factory AND capacity <> 'ERROR'
  GROUP BY f.capacity
  ),
  (SELECT f.capacity AS r2, count(*) AS q2
FROM f_dw_factory f
WHERE capacity <> 'ERROR'
GROUP BY f.capacity)
WHERE r1 = r2
ORDER BY ventesParCapacite DESC;

PROMPT 
PROMPT ********************************** Interpretation ****************************************************
PROMPT 
PROMPT Cette fois on se rend compte qu il y a comme une proportionnalite entre la capacite et le nombre de ventes





