PROMPT
PROMPT ****  Transfert des dates ****
PROMPT
INSERT INTO F_DW_DATES(DATE_VENTE, JDS, JDA, SEMAINE, MOIS,TRIMESTRE, ANNEE) 
SELECT d.getDATE_VENTE(),d.getJDS(),d.getJDA(),d.getSEMAINE(),d.getMOIS(),d.getTrimestre(),d.getYear()
FROM F_BDT_DATES d;
PROMPT
PROMPT ****  Transfert des clients ****
PROMPT
INSERT INTO F_DW_customer(CustomerNumber, Income, Planete, SolarSystem, Quadran, SpeciesCode, Species) 
SELECT c.getCustomerNumber(), c.getIncome(), c.getCustomerAdresse(), c.getSolarSystem(), c.getQuadran(), c.getSpeciesCode(), c.getSpecies()
FROM F_BDT_CUSTOMER c;
PROMPT
PROMPT ****  Transfert des usines ****
PROMPT
INSERT INTO f_dw_factory(Factory, Creation, YearOfCreation, YearOfCreationSeg, Capacity, Planete, SolarSystem, Quadran) 
SELECT f.getFactory(), f.getCreation(), f.getYearOfCreation(), f.getYearOfCreationSeg(), f.getCapacity(), f.getFactoryLocation(), f.getSolarSystem(), f.getQuadran()
FROM F_BDT_FACTORY f;
PROMPT
PROMPT ****  Transfert des produits ****
PROMPT
INSERT INTO f_dw_product(Product, PSize, PSegSize, PSegSize2, Weight, SegWeight, DateOfDesign, DateOfDesignSeg, PType, Planete, SolarSystem, Quadran, BestSeller) 
SELECT p.getProduct(),p.getPSize(), p.getSegSize(), p.getSegSize2(), p.getWeight(), p.getSegWeight(), p.getDateOfDesign(),p.getDateOfDesignSeg(), p.getPType(), p.getDesignLocation(),p.getSolarSystem(), p.getQuadran(),p.getBS()
FROM F_BDT_PRODUCT p;
PROMPT
PROMPT *********  Transfert des ventes *****************
PROMPT
INSERT INTO F_DW_TICKET(FK_DATE,FK_CUSTOMER, FK_FACTORY, FK_PRODUCT) 
SELECT v.getFK_DATE(), v.getFK_CUSTOMER(), v.getFK_Factory(), v.getFK_Product()
FROM F_BDT_SELLING v;
PROMPT
PROMPT ********* Ajout des valeurs erreur si elles ne sont pas presentes dans les tables du dw *********
PROMPT ********* Permet au fk du dw d etre respecte, et permet d etre coherent *********
PROMPT
DECLARE
  nberr number;
BEGIN
  SELECT count(*) INTO nberr FROM F_DW_PRODUCT WHERE Product = 'ERREUR 1';
  if( nberr = 0)
  then
    INSERT INTO F_DW_PRODUCT VALUES ('ERREUR 1',99999,'Erreur', 'Erreur',99999,'Erreur',to_date('1999-01-01','yyyy-mm-dd'),'1999', 'Error', '','','','0');
  end if;
  SELECT count(*) INTO nberr FROM F_DW_PRODUCT WHERE Product = 'ERREUR 2';
  if( nberr = 0)
  then
    INSERT INTO F_DW_PRODUCT VALUES ('ERREUR 2',99999,'Erreur','Erreur',99999,'Erreur',to_date('1999-01-01','yyyy-mm-dd'),'1999', 'Error', '','','','0');
  end if;
END;
/

DECLARE
  nberr number;
BEGIN
  SELECT count(*) INTO nberr FROM F_DW_FACTORY WHERE Factory = 'ERROR';
  if( nberr = 0)
  then
    INSERT INTO F_DW_FACTORY VALUES ('ERROR',to_date('1999-01-01','yyyy-mm-dd'),'0000','0000','ERROR','ERROR','ERROR','ERROR');
  end if;
END;
/
DECLARE
  nberr number;
BEGIN
  SELECT count(*) INTO nberr FROM F_DW_DATES WHERE DATE_VENTE = to_date('1999-01-01','yyyy-mm-dd') ;
  if( nberr = 0)
  then
    INSERT INTO F_DW_DATES VALUES (to_date('1999-01-01','yyyy-mm-dd'),'EXCEPTION',0,0,0,0,'1999');
  end if;
END;
/

DECLARE
  nberr number;
BEGIN
  SELECT count(*) INTO nberr FROM F_DW_CUSTOMER WHERE CustomerNumber = 'ERREUR 1';
  if( nberr = 0)
  then
    INSERT INTO F_DW_CUSTOMER VALUES ('ERREUR 1','ERROR','VIDE','VIDE','E1','ERROR', 'ERROR');
  end if;
  SELECT count(*) INTO nberr FROM F_DW_CUSTOMER WHERE CustomerNumber = 'ERREUR 2';
  if( nberr = 0)
  then
    INSERT INTO F_DW_CUSTOMER VALUES ('ERREUR 2','ERROR','VIDE','VIDE','E1','ERROR', 'ERROR');
  end if;
END;
/
