PROMPT ;
PROMPT **** CREATION DE LA TABLE ET IMPORTATION DES DONNEES DU CSV****;
PROMPT ;

CREATE TABLE f_bde_factory(
  Factory VARCHAR2(255),
  Creation VARCHAR2(255),
  YearOfCreation VARCHAR2(255),
  Capacity VARCHAR2(255),
  FactoryLocation VARCHAR2(255),
  SolarSystem VARCHAR2(255)
)
ORGANIZATION EXTERNAL
(
  TYPE ORACLE_LOADER
  DEFAULT DIRECTORY api98014_src_dir_data
  ACCESS PARAMETERS
  (
    RECORDS DELIMITED BY newline
    CHARACTERSET UTF8
    BADFILE api98014_log:'import.bad'
    LOGFILE api98014_log:'import.log'
    FIELDS TERMINATED BY ';'
    OPTIONALLY ENCLOSED BY '"'
  )
LOCATION ('Factory'))
REJECT LIMIT UNLIMITED;