PROMPT
PROMPT **** CREATION DU TYPE POUR LES PRODUITS *****
PROMPT
/
CREATE OR REPLACE TYPE F_BDT_TYPE_PRODUCT AS OBJECT (
  Product VARCHAR2(255),
  PSize VARCHAR2(255),
  Weight VARCHAR2(255),
  DateOfDesign VARCHAR2(255),
  PType VARCHAR2(255),
  DesignLocation VARCHAR2(255),
  SolarSystem VARCHAR2(255),
  Quadran VARCHAR2(255),
  MEMBER FUNCTION getProduct RETURN VARCHAR2,
  MEMBER FUNCTION getPsize RETURN NUMBER,
  MEMBER FUNCTION getSegSize RETURN VARCHAR2,
  MEMBER FUNCTION getSegSize2 RETURN VARCHAR2,
  MEMBER FUNCTION getWeight RETURN NUMBER,
  MEMBER FUNCTION getSegWeight RETURN VARCHAR2,
  MEMBER FUNCTION getDateOfDesign RETURN DATE,
  MEMBER FUNCTION getDateOfDesignSeg RETURN VARCHAR2,
  MEMBER FUNCTION getPType RETURN VARCHAR2,
  MEMBER FUNCTION getDesignLocation RETURN VARCHAR2,
  MEMBER FUNCTION getSolarSystem RETURN VARCHAR2,
  MEMBER FUNCTION getQuadran RETURN VARCHAR2,
  MEMBER FUNCTION getBS RETURN CHAR
);
/
PROMPT
PROMPT **********  Implementation des methodes  ***************
PROMPT
/

CREATE OR REPLACE TYPE BODY F_BDT_TYPE_PRODUCT
  IS
  MEMBER FUNCTION getProduct RETURN VARCHAR2
  IS
    tmp1 VARCHAR2(2);
    tmp VARCHAR2(20);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(LS)';
    tmp1 := regexp_substr(self.Product, regex);
  
    if (length(tmp1) <> 2)
      then return 'ERREUR 1';
    end if;
    
    regex := '^(LS\d*)';
    tmp := regexp_substr(self.Product, regex);
    
    if (length(tmp) > 2)
      then RETURN tmp;
      else return 'ERREUR 2';
    end if;
  END ;
  MEMBER FUNCTION getPSize RETURN NUMBER
  IS
    tmp1 VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(\d+)';
    tmp1 := regexp_substr(self.PSize, regex);
  
    if (length(tmp1) = 0)
      then return 99999;
      ELSE RETURN to_number(tmp1);
    end if;
  END ;
  MEMBER FUNCTION getSegSize RETURN VARCHAR2
  IS
      tmp VARCHAR2(20);
      regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\d+)';
    tmp := regexp_substr(self.PSize, regex);
    if (length(tmp) =0 )
      then return 'Erreur';
      ELSE IF (to_number(tmp)<101)
        then return '100';
        ELSE IF(to_number(tmp)<201)
          THEN RETURN '200';
          ELSE IF(to_number(tmp)<301)
            THEN RETURN '300';
            ELSE RETURN 'MORE';
            END IF;
          END IF;
        END IF;
    end if;
  END ;
  MEMBER FUNCTION getSegSize2 RETURN VARCHAR2
  IS
      tmp VARCHAR2(20);
      regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\d+)';
    tmp := regexp_substr(self.PSize, regex);
    if (length(tmp) =0 )
      then return 'Erreur';
      ELSE IF (to_number(tmp)<50)
        then return '50';
        ELSE IF(to_number(tmp)<100)
          THEN RETURN '100';
          ELSE IF(to_number(tmp)<150)
            THEN RETURN '150';
            ELSE IF (to_number(tmp)<200)
              then return '200';
              ELSE IF(to_number(tmp)<250)
                THEN RETURN '250';
                ELSE IF(to_number(tmp)<301)
                  THEN RETURN '300';
                  ELSE RETURN 'MORE';
                END IF;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    end if;
  END ;
  MEMBER FUNCTION getWeight RETURN NUMBER
  IS
    tmp1 VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(\d+)';
    tmp1 := regexp_substr(self.Weight, regex);
  
    if (length(tmp1) = 0)
      then return 99999;
      ELSE RETURN to_number(tmp1);
    end if;
  END ;
  MEMBER FUNCTION getSegWeight RETURN VARCHAR2
  IS
      tmp VARCHAR2(10);
      regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\d+)';
    tmp := regexp_substr(self.Weight, regex);
    if (length(tmp) =0 )
      then return 'Erreur';
      ELSE IF (to_number(tmp)<1001)
        then return '1000';
        ELSE IF(to_number(tmp)<2001)
          THEN RETURN '2000';
          ELSE IF(to_number(tmp)<3001)
            THEN RETURN '3000';
            ELSE RETURN 'MORE';
            END IF;
          END IF;
        END IF;
    end if;
  END ;
  MEMBER FUNCTION getDateOfDesign RETURN DATE
  IS
    tmp VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN 
        --Reformater un varchar2 en date: 
        regex := '^([0-9]{4}-[0-1][0-9]-[0-3][0-9])'; 
        tmp := regexp_substr(self.DateOfDesign, regex); 

        if (length(tmp) = 10) 
          then return to_date(tmp, 'yyyy-mm-dd');
          else return to_date('1999-01-01','yyyy-mm-dd'); 
        end if; 
  END ;
  MEMBER FUNCTION getDateOfDesignSeg RETURN VARCHAR2
   IS
    tmp VARCHAR2(255);
    tmp1 VARCHAR2(4);
    regex VARCHAR2(255);
  BEGIN
    regex := '^([0-9]{4})';
    tmp := to_char( self.getDateOfDesign , 'YYYY' );
    tmp1 := regexp_substr(tmp, regex);
    if (length(tmp1) = 0)
      then return '1999';
      ELSE IF ((tmp1>='3000') AND (tmp1<'3010'))
        THEN RETURN '3000';
        ELSE IF ((tmp1>='3010') AND (tmp1<'3020'))
          THEN RETURN '3010';
          ELSE IF ((tmp1>='3020') AND (tmp1<'3030'))
            THEN RETURN '3020';
            ELSE IF ((tmp1>='3030') AND (tmp1<'3040'))
              THEN RETURN '3030';
              ELSE IF ((tmp1>='3040') AND (tmp1<'3050'))
                THEN RETURN '3040';
                ELSE IF ((tmp1>='3050') AND (tmp1<'3060'))
                  THEN RETURN '3050';
                  ELSE IF ((tmp1>='3060') AND (tmp1<'3070'))
                    THEN RETURN '3060';
                    ELSE IF ((tmp1>='3070') AND (tmp1<'3080'))
                      THEN RETURN '3070';
                      ELSE IF ((tmp1>='3080') AND (tmp1<'3090'))
                        THEN RETURN '3080';
                        ELSE IF ((tmp1>='3090') AND (tmp1<'4000'))
                          THEN RETURN '3090';
                          ELSE IF ((tmp1>='4000') AND (tmp1<'4010'))
                            THEN RETURN '4000';
                            ELSE IF ((tmp1>='4010') AND (tmp1<'4020'))
                              THEN RETURN '4010';
                            END IF;
                          END IF;
                        END IF;
                      END IF;
                    END IF;
                  END IF;
                END IF;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    end if;
  END ;
  MEMBER FUNCTION getDesignLocation RETURN VARCHAR2
  IS
    tmp VARCHAR2(30);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(\w+)';
    tmp := regexp_substr(self.DesignLocation, regex);
    if (length(tmp) = 0)
      then return 'VIDE';
      else return tmp;
    end if;
  END ;
  MEMBER FUNCTION getPType RETURN VARCHAR2
  IS
  BEGIN
    if (regexp_like(self.PType,'^Simple$'))
      THEN RETURN 'Simple';
      ELSE IF (regexp_like(self.PType,'^Double$'))
        then return 'Double';
        ELSE IF (regexp_like(self.PType,'^Star$'))
          THEN RETURN 'Star';
          ELSE IF (regexp_like(self.PType,'^Minisword$'))
            THEN return 'Minisword';
            ELSE RETURN 'Error';
          end if;
        end if;
      end if;
    end if;
  END ;
  MEMBER FUNCTION getSolarSystem RETURN VARCHAR2
  IS
  BEGIN
    if self.SolarSystem IS NOT NULL
      THEN RETURN self.SolarSystem;
      ELSE RETURN 'Erreur';
    end if;
  END ;
  MEMBER FUNCTION getQuadran RETURN VARCHAR2
  IS
  BEGIN
    if self.Quadran IS NOT NULL 
      then RETURN self.Quadran;
      else return 'Erreur';
    end if;
  END;
  MEMBER FUNCTION getBS RETURN CHAR
  IS
    tmp VARCHAR2(20);
  BEGIN
    SELECT produit INTO tmp
    FROM F_BDT_BEST_SELL bs
    WHERE  self.getProduct() = bs.produit;
    IF (tmp IS NULL)
      THEN RETURN to_char('0');
      ELSE RETURN '1';
    END IF;
  END;
END ;
/
PROMPT
PROMPT ****  CREATION DE LA TABLE DES VENTES A PARTIR DU TYPE ****
PROMPT
CREATE TABLE F_BDT_PRODUCT OF F_BDT_TYPE_PRODUCT;

PROMPT
PROMPT ****  INSERTION DANS LA TABLE DEPUIS LES TABLES TEMPORAIRES ****
PROMPT
/
INSERT INTO F_BDT_PRODUCT(Product, PSize, Weight, DateOfDesign, PType, DesignLocation, SolarSystem, Quadran)
  SELECT p.Product, p.PSize, p.weight, p.dateofdesign, p.ptype, p.Designlocation, l.SolarSystem, l.Quadran
  FROM F_BDE_PRODUCT p LEFT JOIN f_bdt_location l
  ON p.designLocation = l.Planete;