PROMPT
PROMPT **** CREATION DE LA TABLE ****
CREATE TABLE f_dw_product (
  Product VARCHAR2(20),
  PSize NUMBER,
  PSegSize VARCHAR2(15),
  PSegSize2 VARCHAR2(15),
  Weight NUMBER,
  SegWeight Varchar2(10),
  DateOfDesign DATE,
  DateOfDesignSeg VARCHAR2(4),
  PType VARCHAR2(10),
  Planete VARCHAR2(20),
  SolarSystem VARCHAR2(20),
  Quadran VARCHAR2(6),
  BestSeller CHAR(1)
);

PROMPT *********  Creation des index *****************
CREATE UNIQUE INDEX idx_F_DW_Product_Product ON F_DW_product (Product);

PROMPT *********  Creation des contraintes *****************
ALTER TABLE f_dw_product ADD CONSTRAINT cstr_F_DW_product PRIMARY KEY (Product);
ALTER TABLE f_dw_product ADD CONSTRAINT cstr_F_DW_PSegSize CHECK (PSegSize IN ('100','200','300','MORE','Erreur'));
ALTER TABLE f_dw_product ADD CONSTRAINT cstr_F_DW_SegWeight CHECK (SegWeight IN ('1000','2000','3000','MORE', 'Erreur'));
ALTER TABLE f_dw_product ADD CONSTRAINT cstr_F_DW_PType CHECK (PType IN ('Simple', 'Double', 'Star', 'Minisword', 'Error'));
ALTER TABLE f_dw_product ADD CONSTRAINT cstr_F_DW_BS CHECK (BestSeller IN ('0','1'));
