PROMPT **********************************************************************************
PROMPT **** Question 2 : Analyser les ventes en fonction de l anciennete des usines *****
PROMPT **********************************************************************************
PROMPT 
PROMPT **** Nombre de vente par anciennete ****
PROMPT SELECT f.YearOfCreationSeg AS r1, count(*) AS q1
PROMPT FROM f_dw_factory f, f_dw_ticket ti
PROMPT WHERE ti.fk_factory = f.factory AND YearOfCreationSeg <> '0000'  -- 0000 est le code d'erreur que j ai renvoye en cas de mauvais format de la date de creation, donc on ne le prends pas en compte dans l analyse
PROMPT GROUP BY f.YearOfCreationSeg
PROMPT ORDER BY q1 DESC;
PROMPT

SELECT f.YearOfCreationSeg AS r1, count(*) AS q1
FROM f_dw_factory f, f_dw_ticket ti
WHERE ti.fk_factory = f.factory AND YearOfCreationSeg <> '0000'  -- 0000 est le code d'erreur que j ai renvoye en cas de mauvais format de la date de creation, donc on ne le prends pas en compte dans l analyse
GROUP BY f.YearOfCreationSeg
ORDER BY q1 DESC;

PROMPT 
PROMPT ********************************** Interpretation ****************************************************
PROMPT 
PROMPT On peut voir que les usines construites en 2950 ont plus de ventes que les autres, alors que ce sont les plus anciennes
PROMPT Cependant il ne semble pas y avoir de lien entre l anciennete et les ventes car les valeurs sont assez melanges
PROMPT 
PROMPT Il faudrait faire l analyse en proportion
PROMPT 

PROMPT **** Nombre d usine par anciennete ****
SELECT f.YearOfCreationSeg AS r2, count(*) AS q2
FROM f_dw_factory f
WHERE f.YearOfCreationSeg <> '1999' --1999 est le code d'erreur que j ai renvoye en cas de mauvais format de la date
GROUP BY f.YearOfCreationSeg
ORDER BY f.YearOfCreationSeg DESC;

PROMPT **** Analyse en proportion ****
PROMPT 
PROMPT 
PROMPT 
PROMPT 
PROMPT 
PROMPT SELECT r1 AS Anciennete, q1 AS Ventes, q2 AS NbFactory, ROUND(q1/q2) AS VentesParCapacite FROM
PROMPT   (SELECT f.YearOfCreationSeg AS r1, count(*) AS q1
PROMPT     FROM f_dw_factory f, f_dw_ticket ti
PROMPT     WHERE ti.fk_factory = f.factory AND YearOfCreationSeg <> '0000'  -- 0000 est le code d'erreur que j ai renvoye en cas de mauvais format de la date de creation, donc on ne le prends pas en compte dans l analyse
PROMPT     GROUP BY f.YearOfCreationSeg
PROMPT     ORDER BY q1 DESC
PROMPT   ),
PROMPT   (SELECT f.YearOfCreationSeg AS r2, count(*) AS q2
PROMPT     FROM f_dw_factory f
PROMPT     WHERE f.YearOfCreationSeg <> '1999' --1999 est le code d'erreur que j ai renvoye en cas de mauvais format de la date
PROMPT     GROUP BY f.YearOfCreationSeg
PROMPT     ORDER BY f.YearOfCreationSeg DESC)
PROMPT WHERE r1 = r2
PROMPT ORDER BY ventesParCapacite DESC;
PROMPT 

SELECT r1 AS Anciennete, q1 AS Ventes, q2 AS NbFactory, ROUND(q1/q2) AS VentesParCapacite FROM
  (SELECT f.YearOfCreationSeg AS r1, count(*) AS q1
    FROM f_dw_factory f, f_dw_ticket ti
    WHERE ti.fk_factory = f.factory AND YearOfCreationSeg <> '0000'  -- 0000 est le code d'erreur que j ai renvoye en cas de mauvais format de la date de creation, donc on ne le prends pas en compte dans l analyse
    GROUP BY f.YearOfCreationSeg
    ORDER BY q1 DESC
  ),
  (SELECT f.YearOfCreationSeg AS r2, count(*) AS q2
    FROM f_dw_factory f
    WHERE f.YearOfCreationSeg <> '1999' --1999 est le code d'erreur que j ai renvoye en cas de mauvais format de la date
    GROUP BY f.YearOfCreationSeg
    ORDER BY f.YearOfCreationSeg DESC)
WHERE r1 = r2
ORDER BY ventesParCapacite DESC;

PROMPT 
PROMPT ********************************** Interpretation ****************************************************
PROMPT 
PROMPT Cette fois on se rend compte que les usines construites dans la decennie entre 2950 et 3000 vendent mieux leur produit que les autres
PROMPT L entreprise semblent avoir rater sa phase de modernisation car Plus l anciennete est grande, plus les ventes sont grandes
PROMPT 
