PROMPT **********************************************************************************
PROMPT ***** Question 3 : Analyser les ventes par rapport a la taille des sabres   ******
PROMPT **********************************************************************************
PROMPT 
PROMPT **** Nombre de vente par taille segmente ****
PROMPT 
PROMPT SELECT p.PSegSize AS r1, count(*) AS q1
PROMPT FROM f_dw_product p, f_dw_ticket ti
PROMPT WHERE ti.FK_PRODUCT = p.product AND p.product <> 'ERREUR 1 ' AND p.product <> 'ERREUR 2'
PROMPT GROUP BY p.PsegSize
PROMPT ORDER BY q1 DESC;
PROMPT 
SELECT p.PSegSize AS r1, count(*) AS q1
FROM f_dw_product p, f_dw_ticket ti
WHERE ti.FK_PRODUCT = p.product AND p.product <> 'ERREUR 1 ' AND p.product <> 'ERREUR 2'
GROUP BY p.PsegSize
ORDER BY q1 DESC;

PROMPT 
PROMPT ********************************** Interpretation ****************************************************
PROMPT 
PROMPT On peut voir que les sabres plus grand (tailles comprises entre 100 et 300) semblent mieux se vendre que les petits sabres (tailles < 100)
PROMPT 
PROMPT  Il faudrait faire l analyse en proportion
PROMPT 
PROMPT **** Nombre de sabre par taille segmente ****
PROMPT 
PROMPT SELECT p.psegsize AS r2, count(*) AS q2
PROMPT FROM f_dw_product p
PROMPT WHERE p.product <> 'ERREUR 1' AND p.product <> 'ERREUR 2'
PROMPT GROUP BY p.psegsize;

SELECT p.psegsize AS r2, count(*) AS q2
FROM f_dw_product p
WHERE p.product <> 'ERREUR 1' AND p.product <> 'ERREUR 2'
GROUP BY p.psegsize;

PROMPT **** Analyse en proportion ****
PROMPT 
PROMPT SELECT r1 AS PSegSize, q1 AS Ventes, q2 AS NbSabre, ROUND(q1/q2) AS VentesParTaille FROM
PROMPT   (SELECT p.PSegSize AS r1, count(*) AS q1
PROMPT   FROM f_dw_product p, f_dw_ticket ti
PROMPT   WHERE ti.FK_PRODUCT = p.product AND p.product <> 'ERREUR 1 ' AND p.product <> 'ERREUR 2'
PROMPT   GROUP BY p.PsegSize
PROMPT   ORDER BY q1 DESC
PROMPT   ),
PROMPT   (SELECT p.psegsize AS r2, count(*) AS q2
PROMPT   FROM f_dw_product p
PROMPT   WHERE p.product <> 'ERREUR 1' AND p.product <> 'ERREUR 2'
PROMPT   GROUP BY p.psegsize)
PROMPT WHERE r1 = r2
PROMPT ORDER BY ventesParTaille DESC;

SELECT r1 AS PSegSize, q1 AS Ventes, q2 AS NbSabre, ROUND(q1/q2) AS VentesParTaille FROM
  (SELECT p.PSegSize AS r1, count(*) AS q1
  FROM f_dw_product p, f_dw_ticket ti
  WHERE ti.FK_PRODUCT = p.product AND p.product <> 'ERREUR 1 ' AND p.product <> 'ERREUR 2'
  GROUP BY p.PsegSize
  ORDER BY q1 DESC
  ),
  (SELECT p.psegsize AS r2, count(*) AS q2
  FROM f_dw_product p
  WHERE p.product <> 'ERREUR 1' AND p.product <> 'ERREUR 2'
  GROUP BY p.psegsize)
WHERE r1 = r2
ORDER BY ventesParTaille DESC;

PROMPT 
PROMPT ********************************** Interpretation ****************************************************
PROMPT 
PROMPT 
PROMPT  Cette fois on se rend compte que les sabres les plus vendus sont ceux de grande taille : entre 200 et 300 avec un grand avantages par rapport aux autres. On peut realise une analyse
PROMPT plus fine grace a un deuxieme attribut de segmentation plus fin
PROMPT 

PROMPT 
PROMPT SELECT r1 AS PSegSize2, q1 AS Ventes, q2 AS NbSabre, ROUND(q1/q2) AS VentesParTaille FROM
PROMPT   (SELECT p.PSegSize2 AS r1, count(*) AS q1
PROMPT   FROM f_dw_product p, f_dw_ticket ti
PROMPT   WHERE ti.FK_PRODUCT = p.product AND p.product <> 'ERREUR 1 ' AND p.product <> 'ERREUR 2'
PROMPT   GROUP BY p.PsegSize2
PROMPT   ORDER BY q1 DESC
PROMPT   ),
PROMPT   (SELECT p.psegsize2 AS r2, count(*) AS q2
PROMPT   FROM f_dw_product p
PROMPT   WHERE p.product <> 'ERREUR 1' AND p.product <> 'ERREUR 2'
PROMPT   GROUP BY p.psegsize2)
PROMPT WHERE r1 = r2
PROMPT ORDER BY ventesParTaille DESC;
PROMPT 

SELECT r1 AS PSegSize2, q1 AS Ventes, q2 AS NbSabre, ROUND(q1/q2) AS VentesParTaille FROM
  (SELECT p.PSegSize2 AS r1, count(*) AS q1
  FROM f_dw_product p, f_dw_ticket ti
  WHERE ti.FK_PRODUCT = p.product AND p.product <> 'ERREUR 1 ' AND p.product <> 'ERREUR 2'
  GROUP BY p.PsegSize2
  ORDER BY q1 DESC
  ),
  (SELECT p.psegsize2 AS r2, count(*) AS q2
  FROM f_dw_product p
  WHERE p.product <> 'ERREUR 1' AND p.product <> 'ERREUR 2'
  GROUP BY p.psegsize2)
WHERE r1 = r2
ORDER BY ventesParTaille DESC;


PROMPT 
PROMPT ********************************** Interpretation ****************************************************
PROMPT 
PROMPT On peut voir grace a cette requete que les sabres dont la taille est comprise entre 250 et 300 se vendent mieux que ceux dont la taille est compris entre 200 et 250
PROMPT Les ventes semblent croissantes en fonction de la taille 